local addon = CreateFrame("Frame")
local db
local ammo
local _G = getfenv(0)
local print = function(str) ChatFrame1:AddMessage("AmmoGnome: "..tostring(str)) end
local bags

addon.MERCHANT_SHOW = function(self, event, ...)
	local ammo = db.default
	if not ammo or ammo == "" then
		for b = 1,4 do
			for s = 1,GetContainerNumSlots(b) do
				local item = GetContainerItemLink(b, s)
				if item then
					local sub = select(6, GetItemInfo(item))
					if sub == "Projectile" then
						ammo = GetItemInfo(item)
						bags = b
						break
					end
				end
			end
		end
	end

	if not bags then
		bags = 4
	end

	for mid = 1, GetMerchantNumItems() do
		local mitem = GetMerchantItemInfo(mid)
		if mitem == ammo then
			for slot = 1,GetContainerNumSlots(bags) do
				local item = GetContainerItemLink(bags, slot)
				if not item then
					BuyMerchantItem(mid)
				end
			end
			break
		end
	end
end

addon.ADDON_LOADED = function(self, event, ...)
	if arg1 == "AmmoGnome" then
		if not _G["AmmoGnomeDB"] then
			_G["AmmoGnomeDB"] = {}
		end
		db = _G["AmmoGnomeDB"]

		self:UnregisterEvent("ADDON_LOADED")
		self.ADDON_LOADED = nil
	end
end

addon.BAG_UPDATE = function(self, event, ...)
	if arg1 ~= bags or 4 then return end

	bags = bags or 4
	local ammo = db.default
	if not ammo or ammo == "" then
		for i = 1, GetContainerNumSlots(bags) do
			local item = GetContainerItemLink(bags, i)
			if item then
				break
			end
		end
	end

end

addon:SetScript("OnEvent", function(self, event, ...)
	self[event](self, event, ...)
end)

addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("MERCHANT_SHOW")
-- addon:RegisterEvent("BAG_UPDATE")

local slashH = function(s)
	if not s or s == "" then
		db.default = nil
		print("Default reset, using current ammo")
		return
	end
	if type(s) == "string" then
		if not GetItemInfo(s) then return end
		s = strtrim(s)
		if s:match("item:") then
			-- convert item into words
			local item = GetItemInfo(s)
			db["default"] = item
		else
			db["default"] = s
		end
		print("Default ammo set to:"..GetItemInfo(s))
	end
end

_G.SlashCmdList["AMMOGNOME_DEFAULT"] = slashH
_G.SLASH_AMMOGNOME_DEFAULT1 = "/ag"
